import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
import "Arkangel.dictionary";
import "Arkangel.names";
import "Arkangel.codes";
import "Arkangel.languages";
vis=false
print=Turbine.Shell.WriteLine 
inDict = function(name)
	local found=false
	name=tostring(name)
	for i in pairs(dictionary) do
		if dictionary[i]~= nil and data["Allowed"][string.lower(dictionary[i])]~= true then
		if string.find(string.lower(name),string.lower(dictionary[i])) ~= nil and string.len(dictionary[i]) >= tonumber(data["Options"]["minimumLetters"]) then
			found=true
		end
		end
	end
	for i in pairs(data["Allowed"]) do
		if data["Allowed"][i]== false and string.find(string.lower(name),string.lower(i)) then
		found=true
		end
	end

	if data["Allowed"][string.lower(name)] then
		found=false
	end
	return found
end	


randomName = function(args)
	local name=nil
	taken=True
	local tries=0
	while name==nil or taken and tries <100 do
		tries = tries +1
		name=names
		expected={"race","origin","gender"}
		while type(name) ~= "string" do
			keys={}
			for i in pairs(name) do
				if i ~= "bree"then
					table.insert(keys,i)
				end
			end
			rand=keys[math.random(#keys)]
			potentialname=name[rand]
			for i in pairs(expected) do
				if name[args[expected[i]]] ~= nil then
					potentialname=name[args[expected[i]]]
				end
			end
			if name[1] ~= nil and type(name[1]) ~= "string" then
				prevname=name
			end
			name=potentialname
		
		end
		--Turbine.Shell.WriteLine(prevname[1])
		keys={}
		for i in pairs(prevname[1]) do
			table.insert(keys,i)
		end
		rand=keys[math.random(#keys)]
		firstpart=prevname[1][rand]
		keys={}
		for i in pairs(prevname[2]) do
			table.insert(keys,i)
		end
		rand=keys[math.random(#keys)]
		seccondpart=prevname[2][rand]
		taken=false
		for i in pairs(data["Replacements"]) do
			if data["Replacements"][i] == firstpart..seccondpart then
				taken=true
			end
		end
	end

	if tries >= 100 then
		return "Unable to Rename"
	else
		return firstpart..seccondpart
	end
end
			




----------------------load data----------------------------


dataLoadCompleteEventHandler = function(loadedData)
	data=loadedData
end

function load()
	data=Turbine.PluginData.Load(Turbine.DataScope.Server, "ArkangelData",dataLoadCompleteEventHandler);
end
--see if data exists
--load()
if not pcall(load) then
	Turbine.Shell.WriteLine(strings["Unable to load data"][lang])
	data=defaultData
	Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
	print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")
elseif data==nil then
	Turbine.Shell.WriteLine(strings["Unable to load data"][lang])
	data=defaultData
	Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
	print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")
end

	


--------------------------------------------UI----------


clearwishlist=function()
	HelloWindoww.Message:SetText("");
	wlmsg=""
end
   
HelloWindoww=Turbine.UI.Window(); -- we call the constructor of the standard window object to create an instance
HelloWindoww:SetSize(1000,500); -- sets the window size to 200 by 200 pixels
HelloWindoww:SetPosition(Turbine.UI.Display:GetWidth()/2-500,10); -- centers the window in the display
HelloWindoww:SetText(strings["wishlist"][lang]); -- assigns the title bar text
HelloWindoww:SetMouseVisible(false); 
--HelloWindow=Turbine.UI.Window();
--HelloWindow:SetParent(HelloWindoww);
--HelloWindow:SetSize(400,450); -- sets the window size to 200 by 200 pixels
--HelloWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-100,50); -- centers the window in the display
--HelloWindow:SetText("PocketLM"); -- assigns the title bar text
HelloWindoww.Message=Turbine.UI.Label(); -- create a label control to display our message
HelloWindoww.Message:SetParent(HelloWindoww); -- sets the label as a child of the main window
HelloWindoww.Message:SetSize(1000,500); -- sets the message size
HelloWindoww.Message:SetPosition(10,-1); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
HelloWindoww.Message:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter); -- centers the text in the message control both horizontally and vertically
HelloWindoww.Message:SetText("");
HelloWindoww.Message:SetFont(  Turbine.UI.Lotro.Font.TrajanProBold36);
HelloWindoww.Message:SetMarkupEnabled(true); 
--HelloWindoww.Button=Turbine.UI.Lotro.Button(); -- create a label control to display our message
--HelloWindoww.Button:SetParent(HelloWindoww); -- sets the label as a child of the main window
--HelloWindoww.Button:SetText(strings["clear"][lang]); -- sets the actual message text
--HelloWindoww.Button:SetPosition(140,450); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
--HelloWindoww.Button:SetSize(120,20); -- sets the message size
--HelloWindoww.Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
--HelloWindoww.Button.Click = function()
	--clearwishlist()
--end -- sets the actual message text
HelloWindoww:SetZOrder(1);
--HelloWindow:SetZOrder(0);

--HelloWindow.SButton=Turbine.UI.Lotro.ScrollBar(); -- create a label control to display our message
--HelloWindow.SButton:SetParent(HelloWindow); -- sets the label as a child of the main window
--HelloWindow.SButton:SetPosition(390,10); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
--HelloWindow.SButton:SetSize(12,500); -- sets the message size
--HelloWindow.SButton:SetOrientation(Turbine.UI.Orientation.Vertical);
--HelloWindow.SButton.ValueChanged=function()
--	HelloWindow.Message:SetPosition(10,40-HelloWindow.SButton:GetValue()*80);

--end

 
--HelloWindow:SetVisible(false);--display the window (windows are not visible by default)  


SmallWindow=Turbine.UI.Lotro.Window(); -- we call the constructor of the standard window object to create an instance
SmallWindow:SetSize(450,20); -- sets the window size to 200 by 200 pixels
SmallWindow:SetPosition(100,Turbine.UI.Display:GetHeight()-30); -- centers the window in the display
SmallWindow:SetText("Arkangel"); -- assigns the title bar text
SmallWindow:SetVisible(false);
SmallWindow:SetWantsKeyEvents(true);
SmallWindow.Button2=Turbine.UI.Lotro.Button(); -- create a label control to display our message
SmallWindow.Button2:SetParent(SmallWindow); -- sets the label as a child of the main window
SmallWindow.Button2:SetText(strings["Options"][lang]); -- sets the actual message text
SmallWindow.Button2:SetPosition(30,30); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
SmallWindow.Button2:SetSize(120,20); -- sets the message size
SmallWindow.KeyDown = function(sender,args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		vis=true;
		HelloWindoww:SetVisible(false);
	elseif ( args.Action == 268435635 ) then
		vis= not vis;
	end
	if vis then
		SmallWindow:SetVisible(false);
	else
		SmallWindow:SetVisible(false);
		HelloWindoww:SetVisible(false);
	end
end
 
--HelloWindoww.VisibleChanged=function()
--	HelloWindow:SetVisible(HelloWindoww:IsVisible())
--end
HelloWindoww.PositionChanged=function()
	--HelloWindow:SetLeft(HelloWindoww:GetLeft());
	--HelloWindow:SetTop(HelloWindoww:GetTop()+40);
	HelloWindoww:SetZOrder(1);
	--HelloWindow:SetZOrder(0);
end
wlmsg=""

--------------------------flashing notification

flash = function()
	HelloWindoww:SetWantsUpdates(true)
	startTime=Turbine.Engine.GetDate().Second
	--print(startTime)
end

HelloWindoww.Update = function()
	elapsed=(math.floor(Turbine.Engine.GetDate().Second-startTime))%5
	--print(elapsed)
	if elapsed >5 then
		vis = false
		HelloWindoww:SetVisible(false)
		HelloWindoww:SetWantsUpdates(false)
	elseif elapsed %2 == 0 then
		vis=false
		HelloWindoww:SetVisible(false)
	else
		vis = true
		HelloWindoww:SetVisible(true)
	end
end

--------------------------------------------commands-------------------------------------------------

HelloWindoww.shellCommand=Turbine.ShellCommand();
HelloWindoww.shellCommand.Execute = function(sender, cmd, args)
	local command=args
	print("/arkangel "..command)
	command=string.gsub(command,"\n","")

	local to =nil
	local from = nil
	if string.match(command,"(%w+).+")=="rename" then
		command=string.gsub(command,"rename%s","",1)
		from = string.gsub(command,"%sto.+","")
		command = string.gsub(command,".+%sto%s","")
		if string.match(command,"(%w+).-")=="random"   then
			command=string.gsub(command,"random%s?","")
			to=randomName({["race"]=tostring(string.match(command,"race=(%a+)%s?")),["origin"]=tostring(string.match(command,"origin=(%a+)%s?")),["gender"]=tostring(string.match(command,"gender=(%a+)%s?"))})
		else
			to=command
		end
		data["Replacements"][string.lower(from)]=to
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is renaming"][lang].." </rgb><rgb=0xFF8B00>"..from.."</rgb><rgb=0x00FFE6> "..strings["to"][lang]..  " </rgb><rgb=0xFF8B00>"..to.."</rgb>")
	
	elseif string.lower(string.match(command,"(%w+).+"))=="minimumletters" then
		command=string.lower(command)
		command=string.gsub(command,"minimumletters%s?","",1)
		data["Options"]["minimumLetters"]=tostring(command)
		command=tonumber(command)
		for i in pairs(data["Replacements"]) do
			if inDict(i)==false and string.find(i,command) ~= nil then
				data["Replacements"][i]=string.gsub(i,"^%l", string.upper)
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is returning"][lang].." </rgb><rgb=0xFF8B00>"..string.gsub(i,"^%l", string.upper).."</rgb><rgb=0x00FFE6> "..strings["to their original name"][lang].." </rgb>")
			end
			if inDict(i)==true and string.find(i,command) ~= nil then
				data["Replacements"][i]=randomName({})
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is renaming"][lang].." </rgb><rgb=0xFF8B00>"..i.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i].."</rgb>")

			end

		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel has set the minimum letters in order to automatically rename to"][lang].." </rgb><rgb=0xFFFFFF>"..tostring(command).."</rgb>")
	elseif string.lower(string.match(command,"(%w+).+"))=="customcolors" or string.lower(string.match(command,"(%w+).+"))=="customcolours" then
		command=string.lower(command)
		command=string.gsub(command,"customcolors%s?","",1)
		command=string.gsub(command,"customcolours%s?","",1)


		if command =="off" then
			data["Options"]["customColours"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is now filtering custom chat colours"][lang].."</rgb>")
		elseif command == "on" then
			data["Options"]["customColours"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel has stopped filtering custom chat colours"][lang].."</rgb>")
		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);


	elseif string.lower(string.match(command,"(%w+).-"))=="off" then
		off=true
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is now off"][lang].."</rgb>")
	elseif string.lower(string.match(command,"(%w+).-"))=="on" then
		off=false
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is now on"][lang].."</rgb>")

	elseif string.lower(string.match(command,"(%w+).+"))=="autorenaming" then
		command=string.lower(command)
		command=string.gsub(command,"autorenaming%s?","",1)

		if command =="on" then
			data["Options"]["autoRenaming"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is now automatically renaming characters that may not fit with lore"][lang].."</rgb>")
		elseif command == "off" then
			data["Options"]["autoRenaming"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel has stopped automatically renaming characters that may not fit with lore"][lang].."</rgb>")
		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);

	elseif string.lower(string.match(command,"(%w+).+"))=="channelcolor" or string.lower(string.match(command,"(%w+).+"))=="channelcolour" then
		command=string.lower(command)
		command=string.gsub(command,"channelcolour%s?","",1)
		command=string.gsub(command,"channelcolor%s?","",1)
		local channel = string.gsub(command,"%s.+","")
		--print(channel)
		local colour = string.gsub(command,channel.."%s","")
		--print(colour)
		local channelno = nil

		for i in pairs(chatCodes) do
			--print(string.lower(chatCodes[i]))
			if channel == string.lower(chatCodes[i]) then
				channelno = i
			end
		end
		print(channelno)
		local recog=false
		for i in pairs(colourCodes) do
			if colour==string.lower(i) then
				colour=i
				recog=true
			end
		end
		--print(colour)
		colour=string.gsub(colour,"\#","")
		if not recog then
			colour=string.upper(colour)
		end
		if colourCodes[colour] ~= nil or string.gsub(colour,"%x%x%x%x%x%x","") == "" then
			data["Colours"][channelno]["1"]=colour
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel changed the colour of"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")
		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel does not recognise the colour"][lang].." </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")

		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
		--Turbine.Shell.WriteLine("<rgb=0x00FFE6>Arkangel changed the colour of </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> to </rgb><rgb=0xFFFFFF>"..colour.."</rgb>")



	elseif string.lower(string.match(command,"(%w+).+"))=="channeltoggle" then
		command=string.lower(command)
		command=string.gsub(command,"channeltoggle%s?","",1)
		local channel = string.gsub(command,"%s.+","")
		local toggle = string.gsub(command,".+%s","")
		local channelno = nil
		for i in pairs(chatCodes) do
			if channel == string.lower(chatCodes[i]) then
				channelno = i
				--print(channelno)
			end
		end
		if toggle == "on" and channelno ~= nil then
			data["Colours"][channelno]["2"]=true
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel turned"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["on"][lang].."</rgb>")
		elseif toggle == "off" and channelno ~= nil then
			data["Colours"][channelno]["2"]=false
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel turned"][lang].." </rgb><rgb=0xFFFFFF>"..channel.."</rgb><rgb=0x00FFE6> "..strings["off"][lang].."</rgb>")

		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel does not recognise the toggle value"][lang].."</rgb>")
		end

		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);





		

		

	elseif string.match(command,"(%w+).+")=="view" then
		local hits = false
		local list =""
		command=string.gsub(command,"view%s","",1)
		for i in pairs(data["Replacements"]) do
			if command == "all" or string.lower(command) == i or data["Replacements"][i] == command then
				list=list.."\n".."<rgb=0xFF8B00>"..string.gsub(i,"^%l",string.upper).."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i]
				hits=true
			end
		end
		if hits then
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel has renamed:"][lang].."</rgb>"..list)
		else
			Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel not found anyone with name"][lang].." </rgb><rgb=0xFF8B00>"..command.."</rgb>")
		end


			
			

	elseif string.match(command,"(%w+).+")=="allow" then
		command=string.lower(command)
		command=string.gsub(command,"allow%s","",1)
		data["Allowed"][command]=true

		for i in pairs(data["Replacements"]) do
			if inDict(i)==false and string.find(i,command) ~= nil then
				data["Replacements"][i]=string.gsub(i,"^%l", string.upper)
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is returning"][lang].." </rgb><rgb=0xFF8B00>"..string.gsub(i,"^%l", string.upper).."</rgb><rgb=0x00FFE6> "..strings["to their original name"][lang].." </rgb>")
			end
		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
			
	elseif string.match(command,"(%w+).+")=="ban"  then
		command=string.lower(command)
		command=string.gsub(command,"ban%s","",1)
		data["Allowed"][command]=false

		for i in pairs(data["Replacements"]) do
			if inDict(i)==true and string.find(i,command) ~= nil then
				data["Replacements"][i]=randomName({})
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is renaming"][lang].." </rgb><rgb=0xFF8B00> "..i.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][i].."</rgb>")

			end
		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel will start renaming people with names containing"][lang].." </rgb><rgb=0xFF8B00>"..command.."</rgb>")
	
	elseif string.lower(string.match(command,"(%w+).-"))=="viewcodes"  then
		for i in pairs(playerCodes) do
			print(playerCodes[i]..": "..string.gsub(string.gsub(playerCodes[i],'<','\\<'),'>','\\>'))
		end

	elseif string.lower(string.match(command,"(%w+).+"))=="wishlist"  then
		command=string.lower(command)
		command=string.gsub(command,"wishlist%s","",1)
		if string.lower(string.match(command,"(%w+)%s+"))=="add"  then
			--print("f")
			command=string.gsub(command,"add%s+","",1)
			data["WishList"][command]=true
			print("<rgb=0x00FFE6>"..strings["adding"][lang].." </rgb><rgb=0xFFFFFF>"..command.." <rgb=0x00FFE6>"..strings["to"][lang].." "..strings["wishlist"][lang].."</rgb>")
		elseif string.lower(string.match(command,"(%w+)%s+"))=="remove"  then
			command=string.gsub(command,"remove%s+","",1)
			data["WishList"][command]=nil
			print("<rgb=0x00FFE6>"..strings["removing"][lang].." </rgb><rgb=0xFFFFFF>"..command.." <rgb=0x00FFE6>"..strings["from"][lang].." "..strings["wishlist"][lang].."</rgb>")

		else
			print(strings["Unknown Arkangel command. Please view command list in plugin manager"][lang])
		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);

	elseif string.lower(string.match(command,"(%w+).-"))=="viewwishlist"  then
		for i in pairs(data["WishList"]) do
			if data["WishList"][i]==true then
				print("<rgb=0xFFFFFF>"..i.."</rgb>")
			end
		end

	elseif string.lower(string.match(command,"(%w+).+"))=="reset"  then
		command=string.lower(command)
		command=string.gsub(command,"reset%s","",1)
		command=string.gsub(command,"^%l", string.upper)
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelDataBackup", data);

		if command=="All" then
			data=defaultData
			print("<rgb=0x00FFE6>"..strings["resetting"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")		

		elseif data[command] ~= nil then
			data[command]=defaultData[command]
			print("<rgb=0x00FFE6>"..strings["resetting"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")	
		else
			print("<rgb=0x00FFE6>"..strings["noreset"][lang].." </rgb><rgb=0xFFFFFF>"..command.."</rgb>")	
		end	
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);


	elseif string.lower(string.match(command,"(%w+).+"))=="devmode"  then
		command=string.lower(command)
		command=string.gsub(command,"devmode%s","",1)
		if command == "on" then
			data["Options"]["DevMode"]=true
			print("<rgb=0x00FFE6>"..strings["dmo"][lang].." </rgb>")
		else
			data["Options"]["DevMode"]=false
			print("<rgb=0x00FFE6>"..strings["dmoff"][lang].." </rgb>")

		end
		Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);


			



	elseif string.lower(string.match(command,"(%w+).-"))=="help"  then
		print("<rgb=0x00FFE6>"..strings["help"][lang].." </rgb>")



	else
		Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Unknown Arkangel command. Please view command list by typing /arkangel help"][lang]..".</rgb>")
	end

end
HelloWindoww.tellCommand=Turbine.ShellCommand();
HelloWindoww.tellCommand.Execute = function(sender, cmd, args)
	local command=args
	for i in pairs(data["Replacements"]) do
		if string.lower(i) ~= string.lower(data["Replacements"][i]) then
			command=string.gsub(command,"\("..string.lower(data["Replacements"][i]).."\)",i)
			command=string.gsub(command,"\("..data["Replacements"][i].."\)",i)
		end
	end
end

Turbine.Shell.AddCommand("arkangel",HelloWindoww.shellCommand);
Turbine.Shell.AddCommand("atell",HelloWindoww.tellCommand);

	
----------------------------------------------------chat monitor---------------------------------------------------------------

 -- define the AddCallback function
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	elseif (type(object[event]) == "table") then
		table.insert(object[event], callback);
	else
		object[event] = {object[event], callback};
	end
	return callback;
end


	


ChatMonitor = Turbine.Chat
ChatReceived = function(f, args)
	local msg = args.Message;
	--print(msg);
	local senderxml = nil
	local col = nil
	local sender = nil
	--print(tostring(args.Sendera))
	for i in pairs(data["WishList"]) do
		--print(i)
		if string.find(string.lower(msg),string.lower(i)) ~= nil and data["WishList"][i] == true then
			wlmsg=string.gsub(msg,"<.->","")
			vis=true
			HelloWindoww.Message:SetText(wlmsg);
			HelloWindoww:SetVisible(true);
			flash();
		end
	end
			
	if(args.ChatType ~= 4 and args.ChatType ~= 6 and data["Colours"][tostring(args.ChatType)]["2"] and args.ChatType ~= 25) and msg ~= nil then -- checks that channel can be filtered out and sees if user has hidden channel
		--Turbine.Shell.WriteLine(args.Sender)
		--msg=string.gsub(msg,'<','(')
		--msg=string.gsub(msg,'>',')')
		--Turbine.Shell.WriteLine(msg)
		--Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelSend", sender)
		sender=string.match(msg,">(%a+)<\\Select>.-")
		if string.match(msg,"<(.+)<\\Select>") ~= nil then
			--print("match");
			senderxml="<"..string.match(msg,"<(.+)<\\Select>").."<\\Select>";
		end
		--print(tostring(playerCodes[sender]))
		--print(tostring(senderxml))
		--print(tostring(sender))
		if playerCodes[sender] == nil and senderxml ~= nil and sender ~= nil then
			playerCodes[sender]=senderxml
			Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);
		end
		--Turbine.Shell.WriteLine(sender)
		if inDict(sender) and sender ~= args.Sender and data["Options"]["autoRenaming"] ~= false and sender~=nil and off ~= true then
			if data["Replacements"][string.lower(sender)] == nil then
				data["Replacements"][string.lower(sender)]=randomName({})
				Turbine.Shell.WriteLine("<rgb=0x00FFE6>"..strings["Arkangel is renaming"][lang].." </rgb><rgb=0xFF8B00>"..sender.."</rgb><rgb=0x00FFE6> "..strings["to"][lang].." </rgb><rgb=0xFF8B00>"..data["Replacements"][string.lower(sender)].."</rgb>")
				Turbine.PluginData.Save(Turbine.DataScope.Server, "ArkangelData", data);

			end
		end
		if colourCodes[data["Colours"][tostring(args.ChatType)]["1"]]	~=nil then
			col=colourCodes[data["Colours"][tostring(args.ChatType)]["1"]]
		else
			col="0x"..data["Colours"][tostring(args.ChatType)]["1"]	
		end	
		for i in pairs(playerCodes) do
			msg=string.gsub(msg,"%s+"..i.."%s+",' '..playerCodes[i]..' ')
			msg=string.gsub(msg,i.."%s+",playerCodes[i]..' ')
			msg=string.gsub(msg,i.."%\n",playerCodes[i])
			msg=string.gsub(msg,i.."%,",playerCodes[i]..',')
			msg=string.gsub(msg,i.."%.",playerCodes[i]..'.')
			msg=string.gsub(msg,i.."%?",playerCodes[i]..'?')
			msg=string.gsub(msg,i.."%!",playerCodes[i]..'!')
			msg=string.gsub(msg,string.lower("%s+"..i.."%s+"),string.lower(' '..playerCodes[i]..' '))
			msg=string.gsub(msg,string.lower(i.."%s+"),string.lower(playerCodes[i]..' '))
			msg=string.gsub(msg,string.lower(i.."%\n"),string.lower(playerCodes[i]))
			msg=string.gsub(msg,string.lower(i.."%,"),string.lower(playerCodes[i]..','))
			msg=string.gsub(msg,string.lower(i.."%."),string.lower(playerCodes[i]..'.'))
			msg=string.gsub(msg,string.lower(i.."%?"),string.lower(playerCodes[i]..'?'))
			msg=string.gsub(msg,string.lower(i.."%!"),string.lower(playerCodes[i]..'!'))
			msg=string.gsub(msg,string.upper("%s+"..i.."%s+"),string.upper(' '..playerCodes[i]..' '))
			msg=string.gsub(msg,string.upper(i.."%s+"),string.upper(playerCodes[i]..' '))
			msg=string.gsub(msg,string.upper(i.."%\n"),string.upper(playerCodes[i]))
			msg=string.gsub(msg,string.upper(i.."%,"),string.upper(playerCodes[i]..','))
			msg=string.gsub(msg,string.upper(i.."%."),string.upper(playerCodes[i]..'.'))
			msg=string.gsub(msg,string.upper(i.."%?"),string.upper(playerCodes[i]..'?'))
			msg=string.gsub(msg,string.upper(i.."%!"),string.upper(playerCodes[i]..'!'))


		end
		for i in pairs(data["Replacements"]) do
			if playerCodes[i] ~= nil then
				msg=string.gsub(msg,"%s+"..data["Replacements"][i].."%s+",' '..playerCodes[i]..' ')
				msg=string.gsub(msg,data["Replacements"][i].."%s+",playerCodes[i]..' ')
				msg=string.gsub(msg,data["Replacements"][i].."%\n",playerCodes[i])
				msg=string.gsub(msg,data["Replacements"][i].."%,",playerCodes[i]..',')
				msg=string.gsub(msg,data["Replacements"][i].."%.",playerCodes[i]..'.')
				msg=string.gsub(msg,data["Replacements"][i].."%?",playerCodes[i]..'?')
				msg=string.gsub(msg,data["Replacements"][i].."%!",playerCodes[i]..'!')
				msg=string.gsub(msg,string.lower("%s+"..data["Replacements"][i].."%s+"),string.lower(' '..playerCodes[i]..' '))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%s+"),string.lower(playerCodes[i]..' '))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%\n"),string.lower(playerCodes[i]))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%,"),string.lower(playerCodes[i]..','))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%."),string.lower(playerCodes[i]..'.'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%?"),string.lower(playerCodes[i]..'?'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%!"),string.lower(playerCodes[i]..'!'))
				msg=string.gsub(msg,string.lower(data["Replacements"][i].."%s+"),string.lower(playerCodes[i]..' '))
				msg=string.gsub(msg,string.upper("%s+"..data["Replacements"][i].."%s+"),string.upper(' '..playerCodes[i]..' '))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%\n"),string.upper(playerCodes[i]))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%,"),string.upper(playerCodes[i]..','))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%."),string.upper(playerCodes[i]..'.'))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%?"),string.upper(playerCodes[i]..'?'))
				msg=string.gsub(msg,string.upper(data["Replacements"][i].."%!"),string.upper(playerCodes[i]..'!'))

			end
		end
		msg=string.gsub(msg,'\n','')

		for i in pairs(data["Replacements"]) do
			if string.lower(i) ~= string.lower(data["Replacements"][i]) then
				msg=string.gsub(msg,string.gsub(i,"^%l", string.upper),'('..data["Replacements"][i]..')')
				msg=string.gsub(msg,string.lower(i),string.lower('('..data["Replacements"][i]..')'))
				msg=string.gsub(msg,string.upper(i),string.upper('('..data["Replacements"][i]..')'))
			end
		end
		--msg=string.gsub(msg,'<','(')
		--msg=string.gsub(msg,'>',')')
		--Turbine.Shell.WriteLine(msg)
		if data["Options"]["customColours"] ==true then
			msg=string.gsub(msg,"<.?rgb.->","")
		end
		if data["Options"]["DevMode"]==true then
			msg = string.gsub(string.gsub(msg,"<","\\<"),">","\\>")
		end
	if off ~= true then
		Turbine.Shell.WriteLine('<rgb='..col..'>'..msg..'</rgb>');
	end
end
end



AddCallback(Turbine.Chat, "Received", ChatReceived)

